from time import sleep
from aiges.dto import Response, ResponseData, DataListNode, DataListCls, init_rq
import os

"""personal param"""
model_name = 'wan21_t2v_1_3b'
pretrain_model_name = '/workspace/LLamFile/ModelFile/wan_ai/wan21_t2v_1_3b'

# model_name = 'wan21_i2v_14b'
# pretrain_model_name = '/workspace/LLamFile/ModelFile/wan_ai/wan21_i2v_14b'
output_path = '/workspace/output_dir/wan_output'
finetune_type = 'lora'
infer_type = 'base'
""""""

import sys
print(sys.path)
wrapper = None

result_q = init_rq()

def get_params(patch_id):
    params = {
        "patch_id": patch_id,
        "height":"480",
        "width":"832",
        "sample_steps":50,
        "frame_num":81,
    }
    return params

def Init():
    import os
    os.environ['PRETRAINED_MODEL_NAME'] = model_name
    os.environ['FULL_MODEL_PATH'] = pretrain_model_name
    os.environ['FINETUNE_TYPE'] = finetune_type
    os.environ['INFER_TYPE'] = infer_type
    import importlib
    module_path = f'ailab.utils.wrapper'
    wrapper_module = importlib.import_module(module_path)
    Wrapper = getattr(wrapper_module, 'Wrapper')
    global wrapper
    wrapper = Wrapper()
    config = {}
    wrapper.wrapperInit(config)

def LoadRes(key, zip_file_path):
    with open(zip_file_path, 'rb') as zip_file:
        # 读取压缩包的二进制数据
        zip_data = zip_file.read()
        # 计算数据长度
        zip_data_length = len(zip_data)

    list_node = DataListNode()
    list_node.key = str(key)
    list_node.data = zip_data
    list_node.len = zip_data_length

    req_data = DataListCls()
    req_data.list.append(list_node)
    wrapper.wrapperLoadRes(req_data, key)

def Once(patch_id, text, video_name):
    http_node = DataListNode()
    http_node.key = 'video_description'
    text_data = text.encode('utf-8')
    http_node.data = text_data 
    http_data = DataListCls()
    http_data.list.append(http_node)
    res = wrapper.wrapperOnceExec(get_params(patch_id), http_data)

    full_path = os.path.join(output_path, video_name)
    with open(full_path, 'wb') as file:
        file.write(res.list[0].data)

def OnceAsync(patch_id, text, sid):
    http_node = DataListNode()
    http_node.key = 'video_description'
    text_data = text.encode('utf-8')
    http_node.data = text_data 
    http_data = DataListCls()
    http_data.list.append(http_node)
    wrapper.wrapperOnceExecAsync(get_params(patch_id), http_data, sid)

    # full_path = os.path.join(output_path, video_name)
    # with open(full_path, 'wb') as file:
    #     file.write(res.list[0].data)

def Once_i2v(patch_id, text, video_name, image_file):
    http_node1 = DataListNode()
    http_node1.key = 'video_description'
    text_data = text.encode('utf-8')
    http_node1.data = text_data 

    ## 图片
    http_node2 = DataListNode()
    http_node2.key = 'image'
    with open(image_file, 'rb') as f:
        http_node2.data = f.read()
    
    http_data = DataListCls()
    http_data.list.append(http_node1)
    http_data.list.append(http_node2)
    res = wrapper.wrapperOnceExec(get_params(patch_id), http_data)

    full_path = os.path.join(output_path, video_name)
    with open(full_path, 'wb') as file:
        file.write(res.list[0].data)

def UnloadRes(key):
    wrapper.wrapperUnloadRes(key)

# def StreamCreate(patch_id):
#     params = {
#         "patch_id":patch_id,
#         "temperature":'0.95',
#         "top_k":'60',
#         "max_tokens":'512'
#     }
#     s = wrapper.wrapperCreate(params, 'presid',patch_id)
#     return s.handle

# def StreamWrite(handle,text):
#     http_node = DataListNode()
#     http_node.key = 'messages'
#     text_data = get_messages(text).encode('utf-8')
#     http_node.data = text_data 
#     http_data = DataListCls()
#     http_data.list.append(http_node)

#     wrapper.wrapperWrite(handle,http_data)

def StreamDestroy(handle):
    wrapper.wrapperDestroy(handle)

if __name__ == '__main__' :
    Init()
    # LoadRes('1')
    print("开始推理...")

    # index = 50
    # while index > 0:
    #     prompt = "在水上冲浪的海里,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    #     OnceAsync(f'{index}', prompt,   "9528")
    #     index = index - 1

    sleep(5)
    prompt = "在水上冲浪的小猫和小狗,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    OnceAsync('0', prompt, "9527")

    prompt = "在水上冲浪的小猫和小狗,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    OnceAsync('0', prompt, "9527")

    # prompt = "在水上冲浪的小马,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt, "9528")

    # prompt = "在水上冲浪的小驴,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    # prompt = "在水上冲浪的小孩,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")


    # prompt = "在水上冲浪的小长颈鹿,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    # prompt = "在水上冲浪的小狮子,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    # prompt = "在水上冲浪的大象,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")


    # prompt = "在水上冲浪的龙,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    # prompt = "在水上冲浪的龙,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    # prompt = "在水上冲浪的龙,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    # prompt = "在水上冲浪的龙,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。"
    # OnceAsync('0', prompt,   "9528")

    

    i = 0
    while not result_q.empty():  # 确保队列不为空
        r = result_q.get()  # 取出一个元素
        full_path = os.path.join(output_path, f'video66_{i}.mp4')
        with open(full_path, 'wb') as file:
            file.write(r.list[0].data)  
        i += 1
    
    # with open(full_path, 'wb') as file:
    #     file.write(res.list[0].data)


    sleep(1000)
    print(f"等待。。。")
    sleep(10000)
    # prompt = '在水上冲浪的骆驼,要求：形象在视频中应保持相对稳定的姿态，避免头部大幅运动，画面比例适中（约1/2），位于视频中部且边界与视频框边界的距离不超过宽高的1/5，背景需简洁无复杂动态元素，并确保说话时长占总时长的2/3。'
    # OnceAsync('1', prompt, 'video_10.mp4')
    # Once_i2v('0', prompt, 'video_i2v.mp4', '/workspace/LLamFile/ModelFile/wan_ai/wan21_t2v_1_3b/examples/i2v_input.JPG')
    # if stream:
    #     handle_0 = StreamCreate('1')
    #     StreamWrite(handle_0,'什么是自然语言处理')
    # else:
    #     Once('0', '什么是自然语言处理')
    #     Once('1', '什么是自然语言处理')
    #UnloadRes('1')


